#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n;
    cin >> n;

    vector<long long> v(3, 0);
    long long temp=1, razlika=3, razlika2=3;

    for(int i=3;i<846;i++)
    {
        v.push_back(temp);
        temp+=razlika;
        razlika+=razlika2;
        razlika2++;
    }

    int k=845;
    int brojac=0;
    long long x=0;
    long long y=0;
    string sol="";
    while(n)
    {
        if(v[k]<=n)
        {
            n-=v[k];
            for(int i=0;i<k;i++)
            {
                //cout << x << " " << y << endl;
                sol+=to_string(x) + " " + to_string(y) + '\n';
                x++;
            }
            y++;
            brojac+=k;
            //cout << n << " " << brojac << endl;
        }
        else
        {
            k--;
        }
    }
    cout << brojac << endl << sol;
    return 0;
}